﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.ChartView;
using Telerik.Charting;

namespace sl_ChartView_582099
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            BarSeries ser = new BarSeries();
            ser.DataBindingComplete += new EventHandler(ser_DataBindingComplete);
            ser.ValueBinding = new PropertyNameDataPointBinding("IRBDuration");
            ser.CategoryBinding = new PropertyNameDataPointBinding("EndYear");
            ser.CombineMode = Telerik.Charting.ChartSeriesCombineMode.Stack;
            ser.ShowLabels = true;

            BarSeries ser2 = new BarSeries();
            ser2.DataBindingComplete += new EventHandler(ser_DataBindingComplete);
            ser2.ValueBinding = new PropertyNameDataPointBinding("IRBDuration");
            ser2.CategoryBinding = new PropertyNameDataPointBinding("EndYear");
            ser2.CombineMode = Telerik.Charting.ChartSeriesCombineMode.Stack;
            ser2.ShowLabels = true;

            BarSeries ser3 = new BarSeries();
            ser3.DataBindingComplete += new EventHandler(ser_DataBindingComplete);
            ser3.ValueBinding = new PropertyNameDataPointBinding("IRBDuration");
            ser3.CategoryBinding = new PropertyNameDataPointBinding("EndYear");
            ser3.CombineMode = Telerik.Charting.ChartSeriesCombineMode.Stack;
            ser3.ShowLabels = true;

            chart.Series.Add(ser);
            chart.Series.Add(ser2);
            chart.Series.Add(ser3);
            ser.ItemsSource = this.GenerateItemsSource();
            ser2.ItemsSource = this.GenerateItemsSource();
            ser3.ItemsSource = this.GenerateItemsSource();
        }

        void ser_DataBindingComplete(object sender, EventArgs e)
        {
            var allDataPoints = new List<CategoricalDataPoint>();

            foreach (BarSeries series in this.chart.Series)
            {
                allDataPoints.AddRange(series.DataPoints);
            }

            var groupedDataPoints = allDataPoints.GroupBy<CategoricalDataPoint, object>(dp => dp.Category);

            foreach (var category in groupedDataPoints)
            {
                double sum = 0;

                foreach (var dp in category)
                {
                    dp.Label = "";
                    sum += dp.Value.Value;
                }

                category.Last().Label = "Total: " + sum.ToString();
            }
        }

        private System.Collections.IEnumerable GenerateItemsSource()
        {
            return new List<PlotInfo>() 
            { 
                new PlotInfo { EndYear = "1", IRBDuration = 123, },
                new PlotInfo { EndYear = "2", IRBDuration = 113, },
                new PlotInfo { EndYear = "2", IRBDuration = 143, },
                new PlotInfo { EndYear = "2", IRBDuration = 153, },
                new PlotInfo { EndYear = "4", IRBDuration = 129, },
            };        
        }
    }

    public class PlotInfo
    {
        public string EndYear { get; set; }
        public double IRBDuration { get; set; }
    }
}
